// Q4 108061112 林靖
//
// A positive integer may be represented as a sum of two prime numbers, and
// the representation may not be unique. For example,
//
// 10 = 3 + 7 = 5 + 5
//
// All these integers are prime numbers, except 10 itself.
// Note that 1 is not a prime number, and 2 and 3 cannot be a sum of
// two prime numbers.
//
// Given an integer N, N > 3, please write a program to find the number
// of integers, i, i <= N, which CANNOT be represented by a sum of two
// prime numbers. As mentioned, 1, 2, and 3 are automatically part of
// these numbers.
//
// Example of program execution (assuming N = 20):
// $ ./a.out
// 5 pos int <= 20 cannot be represented by a sum of two prime numbers.
//
// Your program should work for any N, N is an int and N > 3.
// Additional functions can be implemented for this question.

#include <stdio.h>
#include <stdlib.h>

#define N 30

int can_be_repre(int num);
int is_prime(int num);

int main(void)
{
	int num;		// the number to be exam
	int count = 3;	// the number of "cannot be represented..." found
					// (including 1, 2, and 3)

	for (num = 4; num <= N; num++) {	// exam all the num <= given N
		if (!can_be_repre(num)){		// if the num cannot be represented ...
			count++;					// we find such a num
		}
	}
	printf("%d pos int <= %d " , count, N);		// output
	printf("cannot be represented by a sum of two prime numbers.\n");
	return 0;		// noemal program termination
}

int can_be_repre(int num)	// to exam if the num can be represented by
{							// a sum of two prime numbers or not
	int div1, div2;		// the two prime number to test for

	for (div1 = 2; div1 < num; div1++) {	// run through possible prime div1
		if (is_prime(div1)) {				// test if it's a prime num
			for (div2 = 2; div2 < num; div2++) {	// all possible prime div2
				if (is_prime(div2)) {		// test if it's a prime num
					if (num == div1 + div2) {	// if "can be represented..."
						return 1;			// we find such a num
					}
				}
			}
		}
	}
	
	return 0;	// we did not find such a num
}

int is_prime(int num)
{
	int i;	// temp var for looping

	for (i = 2; i * i <= num; i++) {	// test if it can be divided
		if (num % i == 0) {	// if can be divided
			return 0;		// it is not prime
		}
	}

	return 1;	// connot divide, so it's prime
}
